Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/atom_graphnode.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -27,7 +27,7 @@
 void GraphNode::OutputGraphInfo() const
 {
-  Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ";
+  DoLog(2) && (Log() << Verbose(2) << "Atom " << Name << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ");
   OutputComponentNumber();
-  Log() << Verbose(0) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl;
+  DoLog(3) && (Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl);
 };
 
@@ -40,5 +40,5 @@
   if (ComponentNr != NULL) {
     for (int i=0; ComponentNr[i] != -1; i++)
-      Log() << Verbose(0) << ComponentNr[i] << " ";
+      DoLog(2) && (Log() << Verbose(2) << ComponentNr[i] << " ");
   }
 };
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/atom_particleinfo.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -22,5 +22,8 @@
 ostream & operator << (ostream &ost, const ParticleInfo &a)
 {
-  ost << "[" << a.Name << "|" << &a << "]";
+  if (a.Name == NULL)
+    ost << "[NULL]";
+  else
+    ost << "[" << a.Name << "|" << &a << "]";
   return ost;
 };
@@ -28,5 +31,8 @@
 ostream & ParticleInfo::operator << (ostream &ost) const
 {
-  ost << "[" << Name << "|" << this << "]";
+  if (Name == NULL)
+    ost << "[NULL]";
+  else
+    ost << "[" << Name << "|" << this << "]";
   return ost;
 };
Index: src/atom_trajectoryparticle.cpp
===================================================================
--- src/atom_trajectoryparticle.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/atom_trajectoryparticle.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -198,10 +198,10 @@
     // throw a dice to determine whether it gets hit by a heat bath particle
     if (((((rand()/(double)RAND_MAX))*configuration->TempFrequency) < 1.)) {
-      Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ";
+      DoLog(3) && (Log() << Verbose(3) << "Particle " << *this << " was hit (sigma " << sigma << "): " << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << " -> ");
       // pick three random numbers from a Boltzmann distribution around the desired temperature T for each momenta axis
       for (int d=0; d<NDIM; d++) {
         U[d] = gsl_ran_gaussian (r, sigma);
       }
-      Log() << Verbose(0) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl;
+      DoLog(2) && (Log() << Verbose(2) << sqrt(U[0]*U[0]+U[1]*U[1]+U[2]*U[2]) << endl);
     }
     for (int d=0; d<NDIM; d++)
Index: src/bond.cpp
===================================================================
--- src/bond.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/bond.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -63,5 +63,5 @@
   if(rightatom == Atom) 
     return leftatom;
-  eLog() << Verbose(0) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl;
+  DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << *this << " does not contain atom " << *Atom << "!" << endl);
   return NULL;
 };
@@ -99,5 +99,5 @@
 bool bond::MarkUsed(const enum Shading color) {
   if (Used == black) {
-    eLog() << Verbose(0) << "ERROR: Bond " << this << " was already marked black!." << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Bond " << this << " was already marked black!." << endl);
     return false;
   } else {
@@ -113,2 +113,18 @@
   Used = white;
 };
+
+/** Calculates the bond length.
+ * \return |a - b| with a = bond::leftatom and b = bond::rightatom.
+ */
+double bond::GetDistance() const
+{
+  return (leftatom->node->Distance(rightatom->node));
+};
+
+/** Calculates the bond length.
+ * \return |a - b|^2 with a = bond::leftatom and b = bond::rightatom.
+ */
+double bond::GetDistanceSquared() const
+{
+  return (leftatom->node->DistanceSquared(rightatom->node));
+};
Index: src/bond.hpp
===================================================================
--- src/bond.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/bond.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -51,4 +51,6 @@
   bool Contains(const ParticleInfo * const ptr);
   bool Contains(const int nr);
+  double GetDistance() const;
+  double GetDistanceSquared() const;
 
   bond();
Index: src/bondgraph.cpp
===================================================================
--- src/bondgraph.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/bondgraph.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -9,6 +9,8 @@
 
 #include "atom.hpp"
+#include "bond.hpp"
 #include "bondgraph.hpp"
 #include "element.hpp"
+#include "info.hpp"
 #include "log.hpp"
 #include "molecule.hpp"
@@ -35,5 +37,5 @@
 /** Parses the bond lengths in a given file and puts them int a matrix form.
  * Allocates \a MatrixContainer for BondGraph::BondLengthMatrix, using MatrixContainer::ParseMatrix(),
- * but only if parsing is successfull. Otherwise variable is left as NULL.
+ * but only if parsing is successful. Otherwise variable is left as NULL.
  * \param *out output stream for debugging
  * \param filename file with bond lengths to parse
@@ -42,4 +44,5 @@
 bool BondGraph::LoadBondLengthTable(const string &filename)
 {
+  Info FunctionInfo(__func__);
   bool status = true;
   MatrixContainer *TempContainer = NULL;
@@ -47,5 +50,5 @@
   // allocate MatrixContainer
   if (BondLengthMatrix != NULL) {
-    Log() << Verbose(1) << "MatrixContainer for Bond length already present, removing." << endl;
+    DoLog(1) && (Log() << Verbose(1) << "MatrixContainer for Bond length already present, removing." << endl);
     delete(BondLengthMatrix);
   }
@@ -53,5 +56,9 @@
 
   // parse in matrix
-  status = TempContainer->ParseMatrix(filename.c_str(), 0, 1, 0);
+  if ((status = TempContainer->ParseMatrix(filename.c_str(), 0, 1, 0))) {
+    DoLog(1) && (Log() << Verbose(1) << "Parsing bond length matrix successful." << endl);
+  } else {
+    DoeLog(1) && (eLog()<< Verbose(1) << "Parsing bond length matrix failed." << endl);
+  }
 
   // find greatest distance
@@ -80,5 +87,6 @@
 bool BondGraph::ConstructBondGraph(molecule * const mol)
 {
-  bool status = true;
+  Info FunctionInfo(__func__);
+bool status = true;
 
   if (mol->start->next == mol->end) // only construct if molecule is not empty
@@ -113,4 +121,5 @@
 double BondGraph::SetMaxDistanceToMaxOfCovalentRadii(const molecule * const mol)
 {
+  Info FunctionInfo(__func__);
   max_distance = 0.;
 
@@ -153,5 +162,5 @@
 {
   if (BondLengthMatrix == NULL) {// safety measure if no matrix has been parsed yet
-    eLog() << Verbose(1) << "WARNING:  BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "BondLengthMatrixMinMaxDistance() called without having parsed the bond length matrix yet!" << endl);
     CovalentMinMaxDistance(Walker, OtherWalker, MinDistance, MaxDistance, IsAngstroem);
   } else {
@@ -162,3 +171,2 @@
   }
 };
-
Index: src/bondgraph.hpp
===================================================================
--- src/bondgraph.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/bondgraph.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -19,4 +19,8 @@
 
 #include <iostream>
+
+/*********************************************** defines ***********************************/
+
+#define BONDTHRESHOLD 0.4   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii
 
 /****************************************** forward declarations *****************************/
